unit F_MCWizard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls;

type
  TfmMCWizard = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    edtProjectName: TEdit;
    edtPath: TEdit;
    btnOK: TBitBtn;
    btnAnnuler: TBitBtn;
    spdbtnPath: TSpeedButton;
    procedure spdbtnPathClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnAnnulerClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    class function GetMCWizardInfo(var ProjectName,Path:string):boolean;
  end;

implementation

uses UFolderBrowser;

{$R *.DFM}

{ TfmMCWizard }

class function TfmMCWizard.GetMCWizardInfo(var ProjectName,
  Path: string): boolean;
var fmMCWizard:TfmMCWizard;
begin
  fmMCWizard:=TfmMCWizard.Create(nil);
  try
    Result:=fmMCWizard.ShowModal=mrOK;
    ProjectName := fmMCWizard.edtProjectName.text;
    Path        := fmMCWizard.edtPath       .text;
  finally
    fmMCWizard.Free;
  end;
end;

procedure TfmMCWizard.spdbtnPathClick(Sender: TObject);
begin
  edtPath.Text := BrowseForFolder(Handle);
end;

procedure TfmMCWizard.btnOKClick(Sender: TObject);
begin
  if trim(edtProjectName.Text) = '' then
    raise Exception.Create('Nom de projet non valide');

  if(Trim(edtPath.Text) = '') then
    raise Exception.Create('Chemin non valide');
  edtPath.Text:=IncludeTrailingBackslash(edtPath.Text);
  { TODO -oJPP : Vrifier si le chemin est valide }
  ModalResult:=mrOK;
end;

procedure TfmMCWizard.btnAnnulerClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

end.
