//******************************************************************************
// AUTEUR : Frederic Maleval & Jean-Pierre Planas
// DESCRIPTION : Cette unit s'insre dans le FrameWork de test de monte en
//               charge afin de tester la tarification de PPW
//******************************************************************************
unit {<%}MC_FileName{%>};

interface

uses MC_ThreadClt, SysUtils;

type
  {<%}MC_ClassName{%>} = class(TThreadClient)
  public
    function Check_Result(Index:integer;var pResultatAttendu,pResultatRecu:string):boolean;override;
  end;

implementation

//******************************************************************************
//                     Check_Result
//******************************************************************************
// IN.....: Index (INTEGER) = N du thread qui appele cette mthode
// OUT....: pResultatAttendu (STRING) =  Chaine de caractre qui sera affich
//            dans le client de test dans la colonne rsultat Attendu
//          pResultatREcu    (STRING) =  Chaine de caractre qui sera affich
//            sdans le client de test dans la colonne rsultat Recu
//          Result           (BOOLEAN) = Il faut retourner true si le rsultat
//          est correct, sinon, il faut retourner false
// EXPLAIN: Cette mthode est appele automatiquement par le FrameWork de test.
//          L'idal est de varier les tests. Pour cela vous pouvez utiliser le
//          parametre Index qui indique le N du thread. Vous pouvez aussi
//          gnrer un nombre alatoire qui vous fera varier les tests.
//******************************************************************************
function {<%}MC_ClassName{%>}.Check_Result(Index:integer;var pResultatAttendu, pResultatRecu:string):boolean;
begin
{ TODO -oVOUS : Ecrivez votre code ici }

    // ici il faut crire le code de test
    // si par exemple vous voulez tester cette fonction avec plusieurs threads :
    //   function calcul(x:integer):integer;
    //   begin
    //     Result:=x*x;
    //   end;
    // voici un exemple de code de test que vous pourriez mettre  cet endroit:
    // pResultatRecu:=IntToStr(calcul(Index mod 3));
    // Case Index mod 3 of
    //   0 : pResultatAttendu:='0';
    //   1 : pResultatAttendu:='1';
    //   2 : pResultatAttendu:='4';
    // end;

  Result := pResultatAttendu=pResultatRecu;
end;

initialization
// trs important
// ici on spcifie au FrameWork, quelle est la classe de test
  TThreadClient.SetThreadClientClass({<%}MC_ClassName{%>});
end.
