unit UFolderBrowser;

interface

uses shlObj,windows,  ActiveX, sysutils;

function BrowseForFolder(AHandleWin:HWND):string;

implementation

function BrowseForFolder(AHandleWin:HWND):string;
var
    info : BROWSEINFO;
    szDir : array [0..MAX_PATH] of char;
    szDisplayName : array [0..MAX_PATH] of char;
//    pidl : LPITEMIDLIST;{ TODO :  vrifier }
    pidl : PItemIDList;
//    pShellMalloc : LPMALLOC;{ TODO :  vrifier }
    pShellMalloc : IMalloc;
    Directory : string;
begin
    Result:='';
    // SHBrowseForFolder reenvoi un PIDL. La mmoire pour le PIDL est alloue
    // par le shell. On devra donc librer cette mmoire donc nois auront besoin
    // d'un pointeur sur l'objet COM du Shell qui va nous servir  librer cette mmoire
    if(SHGetMalloc(pShellMalloc) = NO_ERROR) then
    begin
        // si on russit  obtenir un pointeur valide on initialise les champs de
        // la structure BROWSEINFO (voir AIDE API Win32)
//        memset(&info, 0x00,sizeof(info));
{ TODO : A remplacer }
        info.hwndOwner:= AHandleWin;             // fentre parente
        info.pidlRoot := nil;                      // racine
        info.pszDisplayName:= szDisplayName;     // display name
        info.lpszTitle:= 'Choisir un dossier';   // label caption
        info.ulFlags  := BIF_RETURNONLYFSDIRS;   // config flags
        info.lpfn:= nil;

        // on execute le fentre de Browsing
        pidl:= SHBrowseForFolder(info);

        // pidl set  NULL si on appui sur "annuler".
        if(pidl<>nil) then
        begin
            // on converti le PIDL en chane
            if(SHGetPathFromIDList(pidl, szDir)) then
            begin
                // on renvoi la chane
                Directory:=szDir;
                Result:=IncludeTrailingBackslash(Directory);
            end;

            pShellMalloc.Free(pidl);//on libre la mmoire allou par le shell au pidl
        end;
        pShellMalloc._Release();//<- un classique
        { TODO : a controler. Parait suspect }
    end;
end;

end.
