unit URunWizard;

interface
uses dialogs,ToolsApi;
// Contient tous les fichiers  gnrer sous forme de constante
{$i StrInc.Inc}

type TMCWizardExec=class
       private
          FProjectName : string;
          FPath        : string;
          FMC_ClassName : string;
          FMC_FileName  : string;
          FMC_ProjectName  : string;
          procedure GenereFichier(FileName:string;ContainStr:string);
        public
          class procedure RunWizard;
     end;

implementation

uses F_MCWizard, UStrUtils;

{ TMCWizard }

procedure TMCWizardExec.GenereFichier(FileName: string;ContainStr:string);
var res:string;
begin
res:=ContainStr;

res:=Str_Replace(res,'{<%}MC_ClassName{%>}'  ,FMC_ClassName,1);
res:=Str_Replace(res,'{<%}MC_FileName{%>}'   ,FMC_FileName,1);
res:=Str_Replace(res,'{<%}MC_ProjectName{%>}',FMC_ProjectName,1);
//ShowMessage(res);

WriteStrToFile(FileName,res);
end;

class procedure TMCWizardExec.RunWizard;
var MCWizardExec:TMCWizardExec;
begin
  MCWizardExec:=TMCWizardExec.Create;
  try
    if not TfmMCWizard.GetMCWizardInfo(MCWizardExec.FProjectName,MCWizardExec.FPath) then exit;

    with MCWizardExec do
      begin
      FMC_ClassName   :='TThreadClient'+FProjectName;
      FMC_FileName    :='MC_ThreadClt' +FProjectName;
      FMC_ProjectName :='CltTestCharge'+FProjectName;

      GenereFichier(FPath+FMC_ProjectName+'.dpr',CltTestCharge_dpr );
      GenereFichier(FPath+FMC_FileName   +'.pas',MC_FileName_pas   );
      GenereFichier(FPath+'MC_Main.dfm'         ,MC_Main_dfm       );
      GenereFichier(FPath+'MC_Main.pas'         ,MC_Main_pas       );
      GenereFichier(FPath+'MC_ThreadClt.pas'    ,MC_ThreadClt_pas  );

      ShowMessage('Projet gnr');
      //ouvre le projet et se positionne
      (BorlandIDEServices as IOTAActionServices).OpenProject(FPath+FMC_ProjectName+'.dpr',false);
      (BorlandIDEServices as IOTAActionServices).OpenFile(FPath+FMC_FileName   +'.pas');
      ((BorlandIDEServices as IOTAModuleServices).FindModule(FPath+FMC_FileName   +'.pas').
         GetModuleFileEditor(0) as IOTASourceEditor).GetEditView(0).GetPosition.GotoLine(37);
       end;
  finally
    MCWizardExec.Free;
  end;

end;

end.
