const CltTestCharge_dpr = '//******************************************************************************'
      +#13#10+'// AUTEUR : Frederic Maleval & Jean-Pierre Planas'
      +#13#10+'// DESCRIPTION : FRAMEWORK de test de monte en charge'
      +#13#10+'//******************************************************************************'
      +#13#10+'program {<%}MC_ProjectName{%>};'
      +#13#10+''
      +#13#10+'uses'
      +#13#10+'  Forms,'
      +#13#10+'  MC_Main in ''MC_Main.pas'' {fmVisu},'
      +#13#10+'  MC_ThreadClt in ''MC_ThreadClt.pas'','
      +#13#10+'  {<%}MC_FileName{%>} in ''{<%}MC_FileName{%>}.pas'';'
      +#13#10+''
      +#13#10+'{$R *.RES}'
      +#13#10+''
      +#13#10+'var fmVisu: TfmVisu;'
      +#13#10+''
      +#13#10+'begin'
      +#13#10+'  Application.Initialize;'
      +#13#10+'  Application.CreateForm(TfmVisu, fmVisu);'
      +#13#10+'  Application.Run;'
      +#13#10+'end.'
 ;
const MC_FileName_pas = '//******************************************************************************'
      +#13#10+'// AUTEUR : Frederic Maleval & Jean-Pierre Planas'
      +#13#10+'// DESCRIPTION : Cette unit s''insre dans le FrameWork de test de monte en'
      +#13#10+'//               charge afin de tester la tarification de PPW'
      +#13#10+'//******************************************************************************'
      +#13#10+'unit {<%}MC_FileName{%>};'
      +#13#10+''
      +#13#10+'interface'
      +#13#10+''
      +#13#10+'uses MC_ThreadClt, SysUtils;'
      +#13#10+''
      +#13#10+'type'
      +#13#10+'  {<%}MC_ClassName{%>} = class(TThreadClient)'
      +#13#10+'  public'
      +#13#10+'    function Check_Result(Index:integer;var pResultatAttendu,pResultatRecu:string):boolean;override;'
      +#13#10+'  end;'
      +#13#10+''
      +#13#10+'implementation'
      +#13#10+''
      +#13#10+'//******************************************************************************'
      +#13#10+'//                     Check_Result'
      +#13#10+'//******************************************************************************'
      +#13#10+'// IN.....: Index (INTEGER) = N du thread qui appele cette mthode'
      +#13#10+'// OUT....: pResultatAttendu (STRING) =  Chaine de caractre qui sera affich'
      +#13#10+'//            dans le client de test dans la colonne rsultat Attendu'
      +#13#10+'//          pResultatREcu    (STRING) =  Chaine de caractre qui sera affich'
      +#13#10+'//            sdans le client de test dans la colonne rsultat Recu'
      +#13#10+'//          Result           (BOOLEAN) = Il faut retourner true si le rsultat'
      +#13#10+'//          est correct, sinon, il faut retourner false'
      +#13#10+'// EXPLAIN: Cette mthode est appele automatiquement par le FrameWork de test.'
      +#13#10+'//          L''idal est de varier les tests. Pour cela vous pouvez utiliser le'
      +#13#10+'//          parametre Index qui indique le N du thread. Vous pouvez aussi'
      +#13#10+'//          gnrer un nombre alatoire qui vous fera varier les tests.'
      +#13#10+'//******************************************************************************'
      +#13#10+'function {<%}MC_ClassName{%>}.Check_Result(Index:integer;var pResultatAttendu, pResultatRecu:string):boolean;'
      +#13#10+'begin'
      +#13#10+'{ TODO -oVOUS : Ecrivez votre code ici }'
      +#13#10+''
      +#13#10+'    // ici il faut crire le code de test'
      +#13#10+'    // si par exemple vous voulez tester cette fonction avec plusieurs threads :'
      +#13#10+'    //   function calcul(x:integer):integer;'
      +#13#10+'    //   begin'
      +#13#10+'    //     Result:=x*x;'
      +#13#10+'    //   end;'
      +#13#10+'    // voici un exemple de code de test que vous pourriez mettre  cet endroit:'
      +#13#10+'    // pResultatRecu:=IntToStr(calcul(Index mod 3));'
      +#13#10+'    // Case Index mod 3 of'
      +#13#10+'    //   0 : pResultatAttendu:=''0'';'
      +#13#10+'    //   1 : pResultatAttendu:=''1'';'
      +#13#10+'    //   2 : pResultatAttendu:=''4'';'
      +#13#10+'    // end;'
      +#13#10+''
      +#13#10+'  Result := pResultatAttendu=pResultatRecu;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'initialization'
      +#13#10+'// trs important'
      +#13#10+'// ici on spcifie au FrameWork, quelle est la classe de test'
      +#13#10+'  TThreadClient.SetThreadClientClass({<%}MC_ClassName{%>});'
      +#13#10+'end.'
 ;
const MC_Main_dfm = 'object fmVisu: TfmVisu'
      +#13#10+'  Left = 331'
      +#13#10+'  Top = 87'
      +#13#10+'  Width = 469'
      +#13#10+'  Height = 488'
      +#13#10+'  BorderIcons = [biSystemMenu, biMinimize]'
      +#13#10+'  Caption = ''Mont''#233''e en charge tarification Plein Phare Web'''
      +#13#10+'  Color = clBtnFace'
      +#13#10+'  Font.Charset = DEFAULT_CHARSET'
      +#13#10+'  Font.Color = clWindowText'
      +#13#10+'  Font.Height = -11'
      +#13#10+'  Font.Name = ''Arial'''
      +#13#10+'  Font.Style = []'
      +#13#10+'  OldCreateOrder = False'
      +#13#10+'  Position = poScreenCenter'
      +#13#10+'  OnCreate = FormCreate'
      +#13#10+'  PixelsPerInch = 96'
      +#13#10+'  TextHeight = 14'
      +#13#10+'  object SG_Resulat: TStringGrid'
      +#13#10+'    Left = 0'
      +#13#10+'    Top = 105'
      +#13#10+'    Width = 461'
      +#13#10+'    Height = 356'
      +#13#10+'    Align = alClient'
      +#13#10+'    ColCount = 6'
      +#13#10+'    DefaultRowHeight = 18'
      +#13#10+'    RowCount = 2'
      +#13#10+'    FixedRows = 0'
      +#13#10+'    ScrollBars = ssVertical'
      +#13#10+'    TabOrder = 0'
      +#13#10+'    ColWidths = ('
      +#13#10+'      64'
      +#13#10+'      74'
      +#13#10+'      76'
      +#13#10+'      64'
      +#13#10+'      64'
      +#13#10+'      64)'
      +#13#10+'  end'
      +#13#10+'  object Panel1: TPanel'
      +#13#10+'    Left = 0'
      +#13#10+'    Top = 0'
      +#13#10+'    Width = 461'
      +#13#10+'    Height = 81'
      +#13#10+'    Align = alTop'
      +#13#10+'    TabOrder = 1'
      +#13#10+'    object Label1: TLabel'
      +#13#10+'      Left = 8'
      +#13#10+'      Top = 13'
      +#13#10+'      Width = 72'
      +#13#10+'      Height = 14'
      +#13#10+'      Caption = ''Nbre de client :'''
      +#13#10+'    end'
      +#13#10+'    object L_Pause: TLabel'
      +#13#10+'      Left = 8'
      +#13#10+'      Top = 48'
      +#13#10+'      Width = 144'
      +#13#10+'      Height = 22'
      +#13#10+'      Caption = ''Veuillez patienter'''
      +#13#10+'      Font.Charset = DEFAULT_CHARSET'
      +#13#10+'      Font.Color = clBlue'
      +#13#10+'      Font.Height = -19'
      +#13#10+'      Font.Name = ''Arial'''
      +#13#10+'      Font.Style = []'
      +#13#10+'      ParentFont = False'
      +#13#10+'      Transparent = True'
      +#13#10+'      Visible = False'
      +#13#10+'    end'
      +#13#10+'    object L_NbClientlMontee: TLabel'
      +#13#10+'      Left = 264'
      +#13#10+'      Top = 51'
      +#13#10+'      Width = 40'
      +#13#10+'      Height = 18'
      +#13#10+'      Alignment = taRightJustify'
      +#13#10+'      Caption = ''1/100'''
      +#13#10+'      Font.Charset = DEFAULT_CHARSET'
      +#13#10+'      Font.Color = clWindowText'
      +#13#10+'      Font.Height = -16'
      +#13#10+'      Font.Name = ''Arial'''
      +#13#10+'      Font.Style = []'
      +#13#10+'      ParentFont = False'
      +#13#10+'      Visible = False'
      +#13#10+'    end'
      +#13#10+'    object SE_NBClient: TSpinEdit'
      +#13#10+'      Left = 80'
      +#13#10+'      Top = 8'
      +#13#10+'      Width = 57'
      +#13#10+'      Height = 23'
      +#13#10+'      MaxValue = 1000'
      +#13#10+'      MinValue = 1'
      +#13#10+'      TabOrder = 0'
      +#13#10+'      Value = 10'
      +#13#10+'    end'
      +#13#10+'    object B_GO: TButton'
      +#13#10+'      Left = 208'
      +#13#10+'      Top = 8'
      +#13#10+'      Width = 97'
      +#13#10+'      Height = 23'
      +#13#10+'      Caption = ''Go !!!'''
      +#13#10+'      Font.Charset = DEFAULT_CHARSET'
      +#13#10+'      Font.Color = clWindowText'
      +#13#10+'      Font.Height = -19'
      +#13#10+'      Font.Name = ''MS Sans Serif'''
      +#13#10+'      Font.Style = []'
      +#13#10+'      ParentFont = False'
      +#13#10+'      TabOrder = 1'
      +#13#10+'      OnClick = B_GOClick'
      +#13#10+'    end'
      +#13#10+'    object PB_Progression: TProgressBar'
      +#13#10+'      Left = 8'
      +#13#10+'      Top = 32'
      +#13#10+'      Width = 297'
      +#13#10+'      Height = 16'
      +#13#10+'      Min = 0'
      +#13#10+'      Max = 100'
      +#13#10+'      TabOrder = 2'
      +#13#10+'      Visible = False'
      +#13#10+'    end'
      +#13#10+'  end'
      +#13#10+'  object SG_Titres: TStringGrid'
      +#13#10+'    Left = 0'
      +#13#10+'    Top = 81'
      +#13#10+'    Width = 461'
      +#13#10+'    Height = 24'
      +#13#10+'    Align = alTop'
      +#13#10+'    ColCount = 6'
      +#13#10+'    RowCount = 1'
      +#13#10+'    FixedRows = 0'
      +#13#10+'    ScrollBars = ssNone'
      +#13#10+'    TabOrder = 2'
      +#13#10+'    ColWidths = ('
      +#13#10+'      64'
      +#13#10+'      74'
      +#13#10+'      76'
      +#13#10+'      64'
      +#13#10+'      64'
      +#13#10+'      64)'
      +#13#10+'  end'
      +#13#10+'  object Timer: TTimer'
      +#13#10+'    Enabled = False'
      +#13#10+'    OnTimer = TimerTimer'
      +#13#10+'    Left = 144'
      +#13#10+'    Top = 8'
      +#13#10+'  end'
      +#13#10+'end'
 ;
const MC_Main_pas = '//******************************************************************************'
      +#13#10+'// AUTEUR : Frederic Maleval & Jean-Pierre Planas'
      +#13#10+'// DESCRIPTION : FRAMEWORK de test de monte en charge'
      +#13#10+'//******************************************************************************'
      +#13#10+'unit MC_Main;'
      +#13#10+''
      +#13#10+'interface'
      +#13#10+''
      +#13#10+'uses'
      +#13#10+'  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,'
      +#13#10+'  StdCtrls, Spin, Grids, ExtCtrls, ComCtrls, MC_ThreadClt;'
      +#13#10+''
      +#13#10+'type'
      +#13#10+'  TfmVisu = class(TForm)'
      +#13#10+'    SG_Resulat: TStringGrid;'
      +#13#10+'    Panel1: TPanel;'
      +#13#10+'    Label1: TLabel;'
      +#13#10+'    L_Pause: TLabel;'
      +#13#10+'    L_NbClientlMontee: TLabel;'
      +#13#10+'    SE_NBClient: TSpinEdit;'
      +#13#10+'    B_GO: TButton;'
      +#13#10+'    PB_Progression: TProgressBar;'
      +#13#10+'    Timer: TTimer;'
      +#13#10+'    SG_Titres: TStringGrid;'
      +#13#10+'    procedure B_GOClick(Sender: TObject);'
      +#13#10+'    procedure Affiche;'
      +#13#10+'    procedure TimerTimer(Sender: TObject);'
      +#13#10+'    procedure EffaceGrille;'
      +#13#10+'    procedure FormCreate(Sender: TObject);'
      +#13#10+'  private'
      +#13#10+'    TempsMax:DWORD; // = temps du thread qui a mis le plus de temps a avoir la reponse'
      +#13#10+'    ListeClient: array of TThreadClient; // liste des threads'
      +#13#10+'  end;'
      +#13#10+''
      +#13#10+'implementation'
      +#13#10+''
      +#13#10+'{$R *.DFM}'
      +#13#10+''
      +#13#10+'procedure TfmVisu.B_GOClick(Sender: TObject);'
      +#13#10+'Var NbClient,i:Word;'
      +#13#10+'begin'
      +#13#10+'  TempsMax := 0;'
      +#13#10+'  SG_Resulat.Color:=clWindow;'
      +#13#10+'  EffaceGrille;'
      +#13#10+'  SE_NBClient.enabled:=false;'
      +#13#10+'  B_GO.enabled:=false;'
      +#13#10+'  L_Pause.visible:=True;'
      +#13#10+'  NbClient:=SE_NBClient.Value;'
      +#13#10+'  SG_Resulat.RowCount:=NbClient;'
      +#13#10+'  SetLength(ListeClient,NbClient);'
      +#13#10+'  for i:= 0 to NbClient-1 do'
      +#13#10+'  begin'
      +#13#10+'    ListeClient[i]:=TThreadClient.GetThreadClientClass.Create(True);'
      +#13#10+'    ListeClient[i].IndexThread:=i;'
      +#13#10+'  end;'
      +#13#10+'  for i:= 0 to NbClient-1 do ListeClient[i].Resume;'
      +#13#10+'  TThreadClient.SetTempsDebut(GetTickCount);'
      +#13#10+'  Timer.enabled:=true;'
      +#13#10+'  PB_Progression.Visible:=True;'
      +#13#10+'  PB_Progression.Max:=NbClient;'
      +#13#10+'  PB_Progression.Position:=0;'
      +#13#10+'  L_NbClientlMontee.caption:=''0/''+IntToStr(NbClient);'
      +#13#10+'  L_NbClientlMontee.Visible:=true;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'procedure TfmVisu.Affiche;'
      +#13#10+'var NbClient,i:Word;'
      +#13#10+'    Ok:Boolean;'
      +#13#10+'begin'
      +#13#10+'  NbClient:=SE_NBClient.Value;'
      +#13#10+'  for i:= 0 to NbClient-1 do if ListeClient[i].Tag = 0 then //On utilise la proprit Tag pour savoir le Thread a affich son rsultat ou non'
      +#13#10+'  begin'
      +#13#10+'    if ListeClient[i].Stop then // si le thread a finit'
      +#13#10+'    begin'
      +#13#10+'      // Remplissage des colonnes'
      +#13#10+'      SG_Resulat.Cells[0,i]:=IntToStr(i);'
      +#13#10+'      SG_Resulat.Cells[1,i]:=ListeClient[i].ResultatRecu;'
      +#13#10+'      SG_Resulat.Cells[2,i]:=ListeClient[i].ResultatAttendu;'
      +#13#10+'      case ListeClient[i].Erreur of'
      +#13#10+'        etNoError         : SG_Resulat.Cells[3,i]:=''OK'';'
      +#13#10+'        etResultsDiffers  : SG_Resulat.Cells[3,i]:=''Erreur'';'
      +#13#10+'        etException       : SG_Resulat.Cells[3,i]:=''Exception'';'
      +#13#10+'      end;'
      +#13#10+'      SG_Resulat.Cells[4,i]:=IntToStr(ListeClient[i].TempsExec )+ '' ms'';'
      +#13#10+'      SG_Resulat.Cells[5,i]:=IntToStr(ListeClient[i].TempsTotal)+ '' ms'';'
      +#13#10+'      // Calcul du tempsMax'
      +#13#10+'      if ListeClient[i].TempsTotal>TempsMax then TempsMax:=ListeClient[i].TempsTotal;'
      +#13#10+'      // Couleur de la stringGrids'
      +#13#10+'      case ListeClient[i].Erreur of'
      +#13#10+'        etNoError         : ;'
      +#13#10+'        etResultsDiffers  : if SG_Resulat.Color<>clRed then SG_Resulat.Color:=$00BBBBFF;'
      +#13#10+'        etException       : SG_Resulat.Color:=clRed;'
      +#13#10+'      end;'
      +#13#10+'      // On en a finit avec ce thread. Il n''aura plus  afficher de rsultat'
      +#13#10+'      ListeClient[i].Tag:=1;'
      +#13#10+'      // Affichage'
      +#13#10+'      Application.ProcessMessages;'
      +#13#10+'      PB_Progression.Position:=PB_Progression.Position+1;'
      +#13#10+'      L_NbClientlMontee.caption:=IntToStr(PB_Progression.Position)+''/''+IntToStr(PB_Progression.Max);'
      +#13#10+'    end;'
      +#13#10+'  end;'
      +#13#10+''
      +#13#10+'  Ok:=True;'
      +#13#10+'  for i:= 0 to NbClient-1 do if ListeClient[i].Tag <> 1 then Ok:=False;'
      +#13#10+''
      +#13#10+'  if Ok then'
      +#13#10+'  begin'
      +#13#10+'    Timer.enabled:=False;'
      +#13#10+'    SE_NBClient.enabled:=True;'
      +#13#10+'    B_GO.enabled:=True;'
      +#13#10+'    L_Pause.visible:=False;'
      +#13#10+'    L_NbClientlMontee.caption:=IntToStr(TempsMax)+'' ms'';'
      +#13#10+'    PB_Progression.Visible:=False;'
      +#13#10+'    application.ProcessMessages;'
      +#13#10+'    // Maintenant on peut librer la mmoire'
      +#13#10+'    for i:= 0 to NbClient-1 do ListeClient[i].Free;'
      +#13#10+'    SetLength(ListeClient,0);'
      +#13#10+'  end;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'procedure TfmVisu.TimerTimer(Sender: TObject);'
      +#13#10+'begin'
      +#13#10+'  application.ProcessMessages;'
      +#13#10+'  Affiche;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'procedure TfmVisu.EffaceGrille;'
      +#13#10+'var i,j:Byte;'
      +#13#10+'begin'
      +#13#10+'  for i:=0 to SG_Resulat.ColCount-1 do'
      +#13#10+'    for j:=0 to SG_Resulat.RowCount-1 do SG_Resulat.Cells[i,j]:='''';'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'procedure TfmVisu.FormCreate(Sender: TObject);'
      +#13#10+'begin'
      +#13#10+'  // Affichage des titres'
      +#13#10+'  SG_Titres.Cells[0,0]:=''N du thread'';'
      +#13#10+'  SG_Titres.Cells[1,0]:=''Res recu'';'
      +#13#10+'  SG_Titres.Cells[2,0]:=''Res attendu'';'
      +#13#10+'  SG_Titres.Cells[3,0]:=''Ok/Erreur ?'';'
      +#13#10+'  SG_Titres.Cells[4,0]:=''Temps exec'';'
      +#13#10+'  SG_Titres.Cells[5,0]:=''Temps total'';'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'end.'
 ;
const MC_ThreadClt_pas = '//******************************************************************************'
      +#13#10+'// AUTEUR : Frederic Maleval & Jean-Pierre Planas'
      +#13#10+'// DESCRIPTION : FRAMEWORK de test de monte en charge'
      +#13#10+'//******************************************************************************'
      +#13#10+'unit MC_ThreadClt;'
      +#13#10+''
      +#13#10+'interface'
      +#13#10+''
      +#13#10+'uses'
      +#13#10+'  Classes,windows,ActiveX, SysUtils;'
      +#13#10+''
      +#13#10+'type'
      +#13#10+'  TErreur = (etNoError, etResultsDiffers, etException);'
      +#13#10+'  TThreadClient= class;  // declaration forward'
      +#13#10+'  TThreadClientClass=class of TThreadClient;  // Meta Classe'
      +#13#10+''
      +#13#10+'  TThreadClient =class(TThread)'
      +#13#10+'  private'
      +#13#10+'    FResultatAttendu : string;'
      +#13#10+'    FResultatRecu    : string;'
      +#13#10+'    FErreur: TErreur;'
      +#13#10+'    FStop: Boolean;'
      +#13#10+'    FTempsTotal: DWORD;'
      +#13#10+'    FTempsExec: DWORD;'
      +#13#10+'  public'
      +#13#10+'    IndexThread     : Integer;  // N du thread'
      +#13#10+'    Tag             : Longint;'
      +#13#10+''
      +#13#10+'    procedure Execute; override;'
      +#13#10+'    function Check_Result(Index:integer;var pResultatAttendu, pResultatRecu:string):boolean;virtual;abstract;'
      +#13#10+'    constructor create(S:Boolean);'
      +#13#10+''
      +#13#10+'    class function  GetTempsDebut : DWORD;'
      +#13#10+'    class procedure SetTempsDebut(Value : DWORD);'
      +#13#10+'    class function  GetThreadClientClass : TThreadClientClass;'
      +#13#10+'    class procedure SetThreadClientClass(Value : TThreadClientClass);'
      +#13#10+''
      +#13#10+'    property TempsTotal      : DWORD   read FTempsTotal     ;'
      +#13#10+'    property TempsExec       : DWORD   read FTempsExec      ;'
      +#13#10+'    property Stop            : Boolean read FStop ;  // Pour savoir si le thread a finit son boulot'
      +#13#10+'    property Erreur          : TErreur read FErreur         ;'
      +#13#10+'    property ResultatAttendu : string  read FResultatAttendu;'
      +#13#10+'    property ResultatRecu    : string  read FResultatRecu   ;'
      +#13#10+'    // Property statiques'
      +#13#10+'    property TempsDebut      : DWORD   read GetTempsDebut write SetTempsDebut;'
      +#13#10+'    property ThreadClientClass :TThreadClientClass read GetThreadClientClass write SetThreadClientClass;'
      +#13#10+'  end;'
      +#13#10+''
      +#13#10+'implementation'
      +#13#10+''
      +#13#10+'uses mc_main;'
      +#13#10+''
      +#13#10+'{ TThreadClient }'
      +#13#10+''
      +#13#10+'// Attributs statiques de la classe TThreadClient.'
      +#13#10+'// Comme Delphi 6 ne permet de faire des attributs statiques, on est oblig de faire des'
      +#13#10+'// variables globales.'
      +#13#10+'// Mais pour limiter leur impact, elles sont locale  l''unit car sous implementation.'
      +#13#10+''
      +#13#10+'var  FTempsDebut:DWORD; // var globale qui contient "l''heure" de dpart du test'
      +#13#10+'     FThreadClientClass:TThreadClientClass; // var globale pour savoir quelle est'
      +#13#10+'                                           // la classe  instancier'
      +#13#10+''
      +#13#10+'constructor TThreadClient.create(S: Boolean);'
      +#13#10+'begin'
      +#13#10+'  inherited;'
      +#13#10+'  FStop := False;'
      +#13#10+'  Tag := 0;'
      +#13#10+'  FErreur := etNoError;'
      +#13#10+'  FResultatAttendu  := ''Non inititialis'';'
      +#13#10+'  FResultatRecu     := ''Non inititialis'';'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'procedure TThreadClient.Execute;'
      +#13#10+'var resAttendu,resRecu:string;'
      +#13#10+'    tempsAvant:DWORD;'
      +#13#10+'begin'
      +#13#10+'  CoInitialize(nil);  // Le thread rentre dans un appartement STA au cas ou il s''agit de tester un objet COM'
      +#13#10+'  try'
      +#13#10+'    FStop := False;'
      +#13#10+'    TempsAvant := gettickcount;'
      +#13#10+'    // Debut du "calcul"'
      +#13#10+'    try'
      +#13#10+'      case Check_Result(IndexThread,resAttendu,resRecu) of'
      +#13#10+'        true  :       FErreur:=etNoError;'
      +#13#10+'        false :       FErreur:=etResultsDiffers;'
      +#13#10+'      end;'
      +#13#10+'      FResultatAttendu := resAttendu ;'
      +#13#10+'      FResultatRecu    := resRecu    ;'
      +#13#10+'    except'
      +#13#10+'      on e:Exception do'
      +#13#10+'        begin'
      +#13#10+'        FErreur:=etException;'
      +#13#10+'        FResultatRecu:=e.Message;'
      +#13#10+'        end;'
      +#13#10+'    end;'
      +#13#10+'    // Fin du "calcul"'
      +#13#10+'    FTempsTotal := gettickcount - TempsDebut;'
      +#13#10+'    FTempsExec  := gettickcount - TempsAvant;'
      +#13#10+'  finally'
      +#13#10+'    CoUninitialize;'
      +#13#10+'    FStop := True;'
      +#13#10+'  end;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'class function TThreadClient.GetTempsDebut : DWORD;'
      +#13#10+'begin'
      +#13#10+'  Result:=FTempsDebut;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'class procedure TThreadClient.SetTempsDebut(Value : DWORD);'
      +#13#10+'begin'
      +#13#10+'  FTempsDebut:=Value;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'class function TThreadClient.GetThreadClientClass : TThreadClientClass;'
      +#13#10+'begin'
      +#13#10+'  Result:=FThreadClientClass;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'class procedure TThreadClient.SetThreadClientClass(Value : TThreadClientClass);'
      +#13#10+'begin'
      +#13#10+'  FThreadClientClass:=Value;'
      +#13#10+'end;'
      +#13#10+''
      +#13#10+'end.'
      +#13#10+''
 ;
